﻿@page "/weather-list"
@inject HttpClient HttpClient
@inject IDialogService DialogService;
@inject NavigationManager __typeHelper
@inject ISnackbar Snackbar
@inject ISessionStorageService SessionStorageService

<PageTitle Title="天気一覧" />

<MudTable Items="@weathers" Loading="@loading" Hover="true" Bordered="true">
    <ToolBarContent>
        <PrefectureSelection @bind-SelectedRegionId="selectedRegionId"
                             @bind-SelectedPrefectureId="selectedPrefectureId" />

        <MudItem xs="12" sm="6" md="4" class="mr-4">
            <MudFab Color="Color.Primary" Icon="@Icons.Material.Filled.Search" Size="Size.Small" Label="表示" OnClick="OnClick" />
            <MudFab Color="Color.Primary" Icon="@Icons.Material.Filled.Add" Size="Size.Small" Label="追加" Link="/weather-detail/create" />
        </MudItem>
    </ToolBarContent>
    <HeaderContent>
        <MudTh>天気ID</MudTh>
        <MudTh>地方名</MudTh>
        <MudTh>都道府県名</MudTh>
        <MudTh>天気日付</MudTh>
        <MudTh>状態</MudTh>
        <MudTh>温度</MudTh>
        <MudTh>アクション</MudTh>
    </HeaderContent>
    <RowTemplate>
        <MudTd DataLabel="WeatherId">@context.WeatherId</MudTd>
        <MudTd DataLabel="RegionName">@context.Prefecture.Region.RegionName</MudTd>
        <MudTd DataLabel="PrefectureName">@context.Prefecture.PrefectureName</MudTd>
        <MudTd DataLabel="WeatherDate">@context.WeatherDate.DisplayValue</MudTd>
        <MudTd DataLabel="Condition">@context.Condition.DisplayValue</MudTd>
        <MudTd DataLabel="Temperature">@context.Temperature.DisplayValue</MudTd>
        <MudTd>
            <MudTooltip Text="編集">
                <MudFab Link=@($"/weather-detail/edit/{context.WeatherId}") Color="Color.Primary" Icon="@Icons.Material.Filled.Edit" Size="Size.Small"></MudFab>
            </MudTooltip>
            <MudTooltip Text="削除">
                <MudFab Color="Color.Primary" OnClick="@(e => Delete(@context.WeatherId))" Icon="@Icons.Material.Filled.Delete" Size="Size.Small"></MudFab>
            </MudTooltip>
        </MudTd>
    </RowTemplate>
</MudTable>

@code {
    private bool loading = false;

    private int selectedRegionId;
    private int selectedPrefectureId;

    private IEnumerable<WeatherEntity> weathers = new List<WeatherEntity>();

    protected async override Task OnInitializedAsync()
    {
        SearchString session = await SessionStorageService.GetItemAsync<SearchString>("SearchString");
        if (session != null)
        {
            selectedRegionId = session.RegionId;
            selectedPrefectureId = session.PrefectureId;
        }
        await OnClick();
    }

    private async Task OnClick()
    {
        loading = true;
        weathers = await HttpClient.GetFromJsonAsync<List<WeatherEntity>>($"api/Weathers?regionId={selectedRegionId}&prefectureId={selectedPrefectureId}");
        loading = false;

        SearchString searchString = new(selectedRegionId, selectedPrefectureId);

        await SessionStorageService.SetItemAsync("SearchString", searchString);
    }

    private async Task Delete(int weatherId)
    {
        WeatherEntity deletedWeather = await HttpClient.GetFromJsonAsync<WeatherEntity>($"api/Weathers/{weatherId}");
        bool? result = await DialogService.ShowMessageBox("警告",
                                                       $"{deletedWeather.Prefecture.PrefectureName}({deletedWeather.WeatherDate.DisplayValue})を削除してもよろしいですか？",
                                                       yesText: "削除",
                                                       cancelText: "キャンセル");
        if (result != null && result == true)
        {
            await HttpClient.DeleteAsync($"api/Weathers/{weatherId}");
            await OnInitializedAsync();
            Snackbar.Add($"{deletedWeather.Prefecture.PrefectureName}({deletedWeather.WeatherDate.DisplayValue}を削除しました。", Severity.Success);
        }
    }

}